﻿/*
------------------------------------------------------------------------------------------------------------------
TurnGrepStyles2CharStyles
------------------------------------------------------------------------------------------------------------------
An InDesign CS4 JavaScript by FourAces, The Final Touch 2006
Based on the original "Turn grep styles to character styles.scpt" AppleScript by Nye Hughes
Version 1.0.0

Converts all the Paragraph Styles applied GREP Styles to standard Character Style applience.
------------------------------------------------------------------------------------------------------------------
*/
if(app.documents.length != 0){
	var myDoc = app.activeDocument;
	var myParaStyles = myDoc.paragraphStyles;
	var myCount = 0;
	var myCharStyleList = "";
	for(i=0; i<myParaStyles.length; i++){
		var myGrepStyles = myParaStyles[i].nestedGrepStyles;
		for(n=0; n<myGrepStyles.length; n++){
			var myGrepFind = myGrepStyles[n].grepExpression;
			var myFindParaStyle = myParaStyles[i];
			var myChangeCharStyle = myGrepStyles[n].appliedCharacterStyle;
			var myGrepChange = NothingEnum.nothing;
			var myFoundItems = runFindChange(myDoc, myGrepFind, myGrepChange, myFindParaStyle, myChangeCharStyle);
			myCount = myCount + myFoundItems.length;
			myCharStyleList = myCharStyleList+"\""+myGrepStyles[n].appliedCharacterStyle.name+"\", ";
		}
	}
	if(myCount > 0){
		alert("Applied character styles:\r"+myCharStyleList+"to "+myCount+" instances of Grep Styled text.");
	}
	else{
		alert("No instances of grep styled characters found.\rNothing Changed.");
	}
}
else{
	alert("Where\'s my document?!\rWell, I\'ll actually need one to perform my magic...");
}

function runFindChange(myObject, FindWhat, ChangetoWhat, FindParaStyle, ChangeCharStyle){
	//Clear the find/change preferences.
	clearFindChangePrefs()
	//Set the find options.
	app.findGrepPreferences.appliedParagraphStyle = FindParaStyle;
	app.findGrepPreferences.appliedCharacterStyle = null;
	app.changeGrepPreferences.appliedCharacterStyle = ChangeCharStyle;
	app.findGrepPreferences.findWhat = FindWhat;
	app.changeGrepPreferences.changeTo = ChangetoWhat;
	return myObject.changeGrep();
}

/*
function setFindChangeOptionstoDefaults(){
	var myFindChangeTextOpts = app.findChangeTextOption;
	myFindChangeTextOpts.caseSensitive = false;
	myFindChangeTextOpts.includeFootnotes = true;
	myFindChangeTextOpts.includeHiddenLayers = false;
	myFindChangeTextOpts.includeLockedLayersForFind = false;
	myFindChangeTextOpts.includeLockedStoriesForFind = false;
	myFindChangeTextOpts.includeMasterPages = true;
	myFindChangeTextOpts.wholeWord = true;
}
*/

function clearFindChangePrefs(){
	//find/change text preferences
	app.findTextPreferences = null;
	app.changeTextPreferences = null;
	//find/change grep preferences
	app.findGrepPreferences = null;
	app.changeGrepPreferences = null;
	//find/change glyph preferences
	app.findGlyphPreferences = null;
	app.changeGlyphPreferences = null;
}